unit Uxml;

// |===========================================================================|
// | UNITE Uxml                                                                |
// | dvelopp par F.BASSO 2006                                                |
// | Unit de gestion des donnes XML de l'application Execas                  |
// |___________________________________________________________________________|
// | Ce programme est libre, vous pouvez le redistribuer et ou le modifier     |
// | selon les termes de la Licence Publique Gnrale GNU publie par la       |
// | Free Software Foundation .                                                |
// | Ce programme est distribu car potentiellement utile,                     |
// | mais SANS AUCUNE GARANTIE, ni explicite ni implicite,                     |
// | y compris les garanties de commercialisation ou d'adaptation              |
// | dans un but spcifique.                                                   |
// | Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.    |
// |                                                                           |
// | anbasso@wanadoo.fr                                                        |
// |___________________________________________________________________________|
// | Versions                                                                  |
// |   2.0.0.0 Permet l'utilisation de la variable %windows% dans les chemins  |
// |           d'application                                                   |
// |   1.0.0.0 Cration de l'unit                                             |
// |===========================================================================|


interface

uses
  SysUtils, Classes, xmldom, XMLIntf, msxmldom, XMLDoc,forms,dialogs,windows;

type
  tfichier = record
    Nom : string;
    exe : string;
    com : string;
  end;
  ttabfichier = array of tfichier;

  TdtXml = class(TDataModule)
    xmlDoc: TXMLDocument;
  private
// ****************************************************************************
// * Dclarations prives                                                     *
// ****************************************************************************

    applications : IXMLNode ;
    function remplacestring(strSource,strRecherche,strPar:string):string;
  public
// ****************************************************************************
// * Dclarations publiques                                                   *
// ****************************************************************************

    function ChargerFichier (var tab : ttabfichier) : integer;
    function SauverFichier (var tab : ttabfichier) : integer;
  end;

var
  dtXml: TdtXml;

implementation

function  TdtXml.remplacestring(strSource,strRecherche,strPar:string):string;
var
  posi : integer;

begin
  posi := pos(lowercase(strRecherche) ,lowercase(strSource) );
  if posi <> 0 then
     result := copy(strsource,0,posi -1 ) + strPar  +
               Copy(strsource,posi + length(strRecherche ),length(strSource) - posi - length(strRecherche )+1)
  else result := strSource ;
end;


// #===========================================================================#
// #===========================================================================#
// #                                                                           #
// # Partie public                                                             #
// #                                                                           #
// #===========================================================================#
// #===========================================================================#

function  TdtXml.ChargerFichier(var tab : ttabfichier):integer;
//  ___________________________________________________________________________
// | function  TdtXml.ChargerFichier                                           |
// | _________________________________________________________________________ |
// || Permet de charger le fichier xml dans un tableau                        ||
// ||_________________________________________________________________________||
// || Entres |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// || Sorties | var tab : ttabfichier                                         ||
// ||         |   tableau de type ttabfichier contenant la liste des programme||
// ||         | result : integer                                              ||
// ||         |   nombre de programmes chargs -1 en cas d'erreur             ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var
  i : integer;
  strNomFichierXml : string;
  strrepAppli      : string;
  intnbFichier     : integer;
  DossierWindows   :array[0..MAX_PATH] of Char;
begin
  GetWindowsDirectory(DossierWindows,MAX_PATH);

  strNomFichierXml := ChangeFileExt(Application.ExeName, '.XML');
  strRepAppli      := ExtractFileDir(strNomFichierXml);
  intnbFichier := 0;
  try

// ****************************************************************************
// * Chargement des info du fichier XML                                       *
// ****************************************************************************

    XMLDoc.LoadFromFile(strNomFichierXml );
    intnbFichier := XMLDoc.DocumentElement.ChildNodes.Count ;
    setlength(tab,intnbFichier);
    for i := 0 to intNbFichier  - 1 do
    begin
      applications := XMLDoc.DocumentElement.ChildNodes[i] ;

// ****************************************************************************
// * Le sous noeud n'est pas Applications le fichier n'est pas conforme       *
// ****************************************************************************

      if applications.NodeName  <> 'Application' then
      begin
        setlength(tab,0);
        result := -1;
      end;
      tab[i].nom  := applications.attributes['nom'] ;
      tab[i].exe  := remplacestring ( applications.ChildNodes['exe'].Text,'%windows%',DossierWindows );
      tab[i].com  := remplacestring ( applications.ChildNodes['com'].Text,'%windows%',DossierWindows );
    end;
    result := intnbfichier;
  except
    result := -1;
  end;
end;

function  TdtXml.SauverFichier(var tab : ttabfichier):integer;
//  ___________________________________________________________________________
// | function  TdtXml.SauverFichier                                            |
// | _________________________________________________________________________ |
// || Permet de sauvegarder la liste des programmes dans un fichier xml       ||
// ||_________________________________________________________________________||
// || Entres | var tab : ttabfichier                                         ||
// ||         |   tableau de type ttabfichier contenant la liste des programme||
// ||_________|_______________________________________________________________||
// || Sorties | result : integer                                              ||
// ||         |   nombre de programmes sauvegards -1 en cas d'erreur         ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var
  i : integer;
  strNomFichierXml : string;
  strrepAppli      : string;
  intnbFichier     : integer;
  applis , def  : IXMLNode;
  DossierWindows   :array[0..MAX_PATH] of Char;
begin
  GetWindowsDirectory(DossierWindows,MAX_PATH);
  strNomFichierXml := ChangeFileExt(Application.ExeName, '.XML');
  strRepAppli      := ExtractFileDir(strNomFichierXml);
  intnbFichier := 0;
  try

// ****************************************************************************
// * Rinitialisation de xmldoc                                               *
// ****************************************************************************

    intnbfichier := length(tab);
    xmlDoc.Active := false;
    xmlDoc.FileName :='';
    xmldoc.XML.Clear ;
    xmlDoc.Active := true;

// ****************************************************************************
// * Cration du noeud principale Applications                                *
// ****************************************************************************

    XMLDoc.DocumentElement := XMLDoc.CreateElement('Applications','');
    for i:=0 to intnbfichier -1 do
    begin

// ****************************************************************************
// * Cration des noeuds Application                                          *
// ****************************************************************************

      applis := XMLDoc.DocumentElement.AddChild('Application');
      applis.SetAttributeNS('nom','',tab[i].nom);
      def := applis.AddChild('exe');
      def.Text :=remplacestring ( tab[i].exe,DossierWindows ,'%windows%');
      def := applis.AddChild('com');
      def.Text := remplacestring (tab[i].com,DossierWindows ,'%windows%');
    end;

// ****************************************************************************
// * Ajout des infos de version XML                                           *
// ****************************************************************************

    xmlDoc.Version :='1.0';
    xmlDoc.StandAlone :='no';
    xmlDoc.encoding := 'UTF-8';

// ****************************************************************************
// * Sauvegarde du flux XML dans le fichier                                   *
// ****************************************************************************

    XMLDoc.SaveToFile (strNomFichierXml );
    result := intnbfichier;
  except
    result := -1;
  end;
end;

{$R *.dfm}

end.
